      PROGRAM UVRAD




      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      PARAMETER ( MLEV=85, MAXCMU=16, MAXUMU=16, MAXULV=2, MAXPHI=1 )
      PARAMETER ( MAXWL = 900 )
      PARAMETER (PI= 3.1415926535898D0 )

      CHARACTER*132 HEADER,filnam*5,filnavn*11

      REAL*8 O3DU(MLEV), TK(MLEV), SIGO3(MAXWL), SIGO2(MAXWL),
     $       SIGRAY(MAXWL), BEXMIE(MLEV), OPDEP(MLEV), SSALB(MLEV),
     $       SSALBM(MLEV), GH(MLEV), HAZELM(0:82), FLX(MAXWL), 
     $       UTAU(MAXULV), COSTH(MAXUMU), PHI(MAXPHI), PMB(MLEV),
     $       RTAU(0:MLEV),RF(900),taudep(21)
      REAL*8 TEMPER(0:MLEV), HL(0:MAXCMU), ALBMED(MAXUMU),
     $       TRNMED(MAXUMU), INTENS(MAXWL), O3DEP(MLEV),
     $       TAUSLANT(MLEV), SANNS(MLEV), DU3(MLEV),arr(900)

      REAL*8 PMOM(0:MAXCMU,MLEV), RFLDIR(MAXULV), RFLDN(MAXULV),
     $       FLUP(MAXULV), DFDT(MAXULV), UAVG(MAXULV), ZKM(MLEV),
     $       UU(MAXUMU, MAXULV, MAXPHI), U0U(MAXUMU,MAXULV),rn(100)

      LOGICAL USRTAU, USRANG, LAMBER, NOPLNK, ONLYFL, SPHER, HG,
     $        DELTAM, ONLYPR, PRNT(7)
      character deltam_answ*3


 

	open(20,file='spect.out')


      CALL READIN (INSTR, IDIR, ISCAT, SPHER, ALBEDO, NSTR, MISCAT,
     $             HG, DELTAM, ISONDE, ZKM, PMB, TK, O3DU, BEXMIE,
     $             SSALBM, NLYR, MLEV, ONLYPR, IDIFF, GH, ITOMS,gg )


      deltam_answ = ' No'
      if(deltam) deltam_answ = 'Yes'


	sumo3 = 0.0d0
	do i = 1, nlyr
	sumo3 = sumo3 + o3du(i)
	end do

      CALL READUV ( FLX, SIGO2, SIGO3, SIGRAY )


      


      DO LC = 1, NLYR
	   DU3(LC)= O3DU(LC)
      END DO





c        go to 87

 30     write(6,*) 'Enter Solar Zenith Angle [degrees]:'
        read(5,*) rzenang

        if(rzenang.lt.0.0 .or.rzenang.gt.89.9) then
         write(6,*) '******* Illegal value ******'
         do i = 1,6
         write(6,*)
         end do
         write(6,*) 'Try again'
         go to 30
        end if

        write(6,*)
        
        write(6,*) 'Enter Total ozone abundance [DU]:'
        read(5,*) rdob
        
        write(6,*)

 86     continue
        write(6,*) 'surface albedo:'
        read(5,*) albedo
        if(albedo .lt. 0.0d0 .or. albedo .gt. 1.0d0) then
           write(6,*) '***** error ******'
           write(6,*) 'Albedo > 1.0 or < 0.0 not allowed!'
           write(6,*) 'Try again'
           go to 86
         end if

 85      continue
        write(6,*) 'wavelength start [nm] :'
        read(5,*) wr
        iws = int(wr+0.01)


        write(6,*) 'wavelength end [nm] :'
        read(5,*) wr
        iwe = int(wr+0.01)

        if(iws .gt. iwe ) then
           iw = iwe
           iwe = iws
           iws = iw
        end if

        if(iwe .gt. 800 .or. iws .lt. 200) then
           write(6,*)
           write(6,*) 'Only wavelength range 200-800nm allowed!'
           write(6,*) 'Try again'
           go to 85
        end if


        write(6,*)
        write(6,*)

        write(6,*) 'include cloud layer?'
        write(6,*) 'yes = 1    no = 2'
        read(5,*) icl
        if(icl.ne.1) icl = 2

        do lc = 1,nlyr
          bexmie(i) = 0.0d0
        end do

        if(icl .eq. 1) then

 87        continue
          write(6,*) 'cloud layer, base [km]: '
          read(5,*) r2
          ir2 = int(r2+0.01d0)
          write(6,*) 'cloud layer, top [km]:'
          read(5,*) r1
          ir1 = int(r1+0.01d0)

          if(ir1 .lt. ir2 .or. ir2 .eq. ir1) then
             write(6,*) '************ error ********'
             write(6,*) 'cloud top height must be larger than',
     $       ' cloud base height !'
             write(6,*) 'Try again'
             write(6,*)
             go to 87
          end if
          
          if(ir1 .gt. 79 .or. ir2 .gt. 79) then
             write(6,*)
             write(6,*) 'Cloud layer too high (base max = 79 km)'
             write(6,*)
             go to 87
          end if
          
          write(6,*) 'cloud optical depth:'
          read(5,*) dt
        
        lcbase = nlyr - ir2
        lctop = nlyr  - ir1

  

        do lc = lctop+1,lcbase
           bexmie(lc) = dt/(lcbase - lctop)

        end do

        end if

        do i = 1,10
           write(6,*)
        end do
        
        write(6,*) 'wait - working...'
	

	zenang=rzenang


	 DO LC = 1, NLYR
	   O3DU(LC) = DU3(LC)
	 END DO

	 FRO3 = RDOB/sumo3
c        fro3 = (rdob - sumo3 + o3part)/o3part
	 DO LC = 1, NLYR
	     O3DU(LC) = FRO3*O3DU(LC)
c         if((zkm(lc).gt.10.0d0) .and. (zkm(lc).lt.32.0d0) ) then
c            o3du(lc) = fro3*o3du(lc)
c         end if
	 END DO

 
         write(20,73) nstr
         write(20,72) deltam_answ
         write(20,76) gg
 76      format('Asymmetry factor: ',f6.4)
 73      format('Number of streams used: ', i4)
 72      format('Delta-m scaling : ',a3)
         write(20,60) rdob
 60      format('Ozone [DU]:',f8.2)
         if(icl.eq.1) then
         write(20,*) 'cloud base  [km]:', ir2
         write(20,*) 'cloud top   [km]:', ir1
         write(20,61) dt
 61      format('Cloud optical depth:',f9.4)
         else
         write(20,*) 'Clear sky'
         end if
         write(20,62) rzenang
 62      format('Solar Zenith Angle [degrees:]',f6.2)
         write(20,63) albedo
 63      format('Surface albedo:',f4.2)
         write(20,*)
         write(20,*) '                Spectral irradiances'
         write(20,*) '                ********************'
         write(20,*)
         write(20,*) '        <--------- bottom of atm ------------->','
     $    <-top of atm->'
         write(20,*) 'Wavel   Down direct   Diffuse down   Diffuse up','
     $    Diffuse up'
         write(20,*) '[nm]    [W/nm/m**2]    [W/nm/m**2]  [W/nm/m**2]',
     $ '     [W/nm/m**2]'




	do 1000 iwl = iws,iwe

      

c rayleigh cross sections (Nicolet's formulae from 1984)
        rr = iwl/1000.0
	xx = 0.389d0*rr + 0.09426d0/rr - 0.3228d0
	sigray(iwl) = 4.02d-28/(rr**(4.0d0+xx))
 


	 CALL OPTICP( BEXMIE, GH, HAZELM, IWL, MAXCMU, MLEV, NLYR,
     $                OPDEP, O3DU, PMB, PMOM, SIGRAY, SIGO2, SIGO3,
     $                SSALB, SSALBM, TK, ZKM, NSTR, MISCAT, DOBSON,
     $                O3DEP, HG, TOTMIE )

	



	 CALL SETUP (USRTAU, NTAU, UTAU, USRANG, NSETA, COSTH,
     $               NPHI, IBCND, X0, PHI, FISOT, LAMBER, NOPLNK,
     $               ONLYFL, ACCUR, INSTR, OPDEP, NLYR, ZENANG,
     $               MAXULV, MAXPHI, MAXUMU, PHI0, MLEV, PRNT)

	 FBEAM = FLX(IWL)

	   IF(IDIFF.EQ.2) DIFFUS = 0.0D0

       

	
         call disort( nlyr,opdep, ssalb, pmom, temper, wvnmlo,
     $                wvnmhi, usrtau, ntau, utau, nstr, usrang,
     $                nseta, costh, nphi, phi, ibcnd, fbeam, x0,
     $                phi0, fisot, lamber, albedo, hl, gtemp,
     $                ttemp, temis, deltam, noplnk, onlyfl,
     $                accur, prnt, header, mlev, maxulv,
     $                maxumu, maxcmu, maxphi, rfldir, rfldn,
     $                flup, dfdt, uavg, uu, u0u, albmed, trnmed,
     $                zkm, zenang, spher, onlypr )



        write(20,70) iwl, rfldir(1),rfldn(1),flup(1),flup(2)
 70     format(i3,5x,e10.4,5x,e10.4,5x,e10.4,5x,e10.4)
 71     format(i3,5x,e10.4)

1000  CONTINUE

	totflux = 0.0d0

2000  CONTINUE

3000    continue

        do i = 1,20
           write(6,*)
        end do

        write(6,*) 'Output file:  spect.out'

        do i = 1,6
           write(6,*)
        end do
        write(6,*) 'Hit ENTER-key to end program'
        read(5,*)

103   FORMAT(F6.2,5X,F10.3)
108     format(F6.2,5X,F10.3,5x,f5.1,5x,f7.3)
104   FORMAT(F6.2,5X,F10.3,5X,F10.3)

      END

C ****************** SUBROUTINE OPTICP ***********************************

      SUBROUTINE OPTICP( BEXMIE, GH, HAZELM, IWL, MAXCMU, MLEV, NLYR,
     $                   OPDEP, O3DU, PMB, PMOM, SIGRAY, SIGO2, SIGO3,
     $                   SSALB, SSALBM, TK, ZKM, NSTR, MISCAT, DOBSON,
     $                   O3DEP, HG, TOTMIE )

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      LOGICAL HG

      REAL*8 NO3, NO2, NATM
      REAL*8 O3DU(*), PMB(*), TK(*),SIGO3(*), SIGO2(*),
     $       SIGRAY(*), BEXMIE(*), OPDEP(*), SSALB(*),
     $       SSALBM(*), GH(*), HAZELM(0:82), PMOM(0:MAXCMU,MLEV),
     $       ZKM(*), O3DEP(*)

      DOBSON = 0.0d0

      TOTMIE = 0.0D0

      dtaumi = 0.0d0

      DO 10 LC = 1, NLYR
	DOBSON = DOBSON + O3DU(LC)
	DELZ = ZKM(LC) - ZKM(LC+1)
	NO3 = 2.68684D17*O3DU(LC)/ DELZ
	NATM = ( PMB(LC)/TK(LC) + PMB(LC+1)/TK(LC+1) )
     $         * 50.0D0/ 1.380622D-23
	NO2 = 0.2095*NATM
	DTAUO3 = SIGO3(IWL) * NO3 * DELZ*0.1D0
	DTAUO2 = SIGO2(IWL) * NO2 * DELZ*0.1D0
	DTAURA = SIGRAY(IWL) * NATM * DELZ*0.1D0
	IF(MISCAT.EQ.1) DTAUMI = BEXMIE(LC) * DELZ
	IF(MISCAT.EQ.1) TOTMIE = TOTMIE + DTAUMI
	OPDEP(LC) = DTAUO3 + DTAUO2 + DTAURA + DTAUMI 
	O3DEP(LC) = DTAUO3
	SSALB(LC) = (DTAURA + SSALBM(LC)*DTAUMI) / OPDEP(LC)
	IF(SSALB(LC).GT.0.9999D0) SSALB(LC) = 0.9999D0
	DO L = 1,NSTR
	  PMOM(L,LC) = 0.0D0
	END DO
	PMOM(0,LC) = 1.0D0
	IF(MISCAT.EQ.1) THEN
	   DO 20 L = 1, NSTR
	      IF (HG) THEN
		 PM = GH(LC)**(L)
	      ELSE
		 PM = HAZELM(L)
	      END IF
	      PMOM(L,LC) = SSALBM(LC)*DTAUMI*PM / 
     $                  ( DTAURA + SSALBM(LC)*DTAUMI )
20         CONTINUE
	END IF
	PMOM(2,LC) = PMOM(2,LC) + DTAURA / (10.0D0*( DTAURA
     $               + SSALBM(LC)*DTAUMI ) )
10    CONTINUE

      RETURN
      END

C ******************* END OF OPTICP ***********************************

C ******************* SUBROUTINE READUV *******************************

      SUBROUTINE READUV ( FLX, SIGO2, SIGO3, SIGRAY )

      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      REAL*8 FLX(*), SIGO2(*), SIGO3(*), SIGRAY(*)

      OPEN(10, FILE= 'solar.inp', STATUS='OLD')

	read(10,*)
	read(10,*)
	read(10,*)
	read(10,*)
	read(10,*)
	

1     READ(10,*,END=99) iWL, RN, CROX, CROZ

	
      FLX(IWL) = rn*1.0d0
      SIGRAY(IWL) = CRR*1.0d0
      SIGO2(IWL) = CROX*1.0d0
      SIGO3(IWL) = CROZ*1.0d0
      GO TO 1

99    CLOSE(10)

      RETURN
      END

C ***************** END IF READUV **************************************
C ******************* SUBROUTINE SETUP ***********************************

      SUBROUTINE SETUP (USRTAU, NTAU, UTAU, USRANG, NSETA, COSTH,
     $                  NPHI, IBCND, X0, PHI, FISOT, LAMBER, NOPLNK,
     $                  ONLYFL, ACCUR, INSTR, OPDEP, NLYR, ZENANG,
     $                  MAXULV, MAXPHI, MAXUMU, PHI0, MLEV, PRNT )

      IMPLICIT DOUBLE PRECISION ( A-H, O-Z )

      PARAMETER (PI = 3.1415926535898D0 )

      REAL*8 UTAU(*), COSTH(*), PHI(*), OPDEP(*)
      LOGICAL USRTAU, USRANG, LAMBER, NOPLNK, ONLYFL, PRNT(7)

      DO I = 1, 7
	 PRNT(I) = .FALSE.
c test
c       prnt(i) = .true.
c test
      END DO


	 USRTAU=.TRUE.
	 UTAU(1) = 0.0D0
	 DO 10 LC = 1, NLYR
	    UTAU(1) = UTAU(1) + OPDEP(LC)
10       CONTINUE
	 NTAU = 2
         utau(2) = 0.0d0

      NSETA = 1
      

      X0 = DCOS( ZENANG*PI/180.0D0 )
      NPHI=1
      PHI(1) = 0.0D0
      PHI0=0.0D0
      FISOT = 0.0D0
      ACCUR = 1.0D-8
      LAMBER = .TRUE.
      NOPLNK = .TRUE.
      ONLYFL = .true. 
      USRANG = .false.
      costh(1) = -1.0d0


      RETURN
      END

C ************************* END OF SETUP *************************************

C *********************** SUBROUTINE READIN **********************************

      SUBROUTINE READIN (INSTR, IDIR, ISCAT, SPHER, ALBEDO, NSTR,
     $miscat,HG, DELTAM, ISONDE, ZKM, PMB, TK, O3DU, BEXMIE,
     $SSALBM, NLYR, MLEV, ONLYPR, IDIFF, GH, ITOMS,gg )

      IMPLICIT DOUBLE PRECISION (A-H, O-Z)

      LOGICAL SPHER, HG, DELTAM, ONLYPR
      REAL*8 ZKM(*), PMB(*), TK(*), O3DU(*), BEXMIE(*),
     $       SSALBM(*), GH(*)
       character*20 filnam



c        OPEN(1,FILE='atm.INP', STATUS='OLD')
        OPEN(1,FILE='subarcticwinterN.atm', STATUS='OLD')
c       OPEN(1,FILE='trop.inp') 
 
     
c      CALL SKIP(2)
c      READ(1,*) IDIFF
      CALL SKIP(1)
      READ(1,*) ISPHER
      SPHER=.FALSE.
      IF(ISPHER.EQ.1) SPHER = .TRUE.
c      CALL SKIP(1)
c      READ(1,*) ALBEDO
      CALL SKIP(1)
      READ(1,*) NSTR
      CALL SKIP(1)
      READ(1,*) MISCAT
      CALL SKIP(1)
      READ(1,*) IPHAS
      HG=.FALSE.
      IF(IPHAS.EQ.1) HG=.TRUE.
      CALL SKIP(1)
      READ(1,*) GG
      CALL SKIP(1)
      READ(1,*) IDELM
      DELTAM = .FALSE.
      IF(IDELM.EQ.1) DELTAM =.TRUE.
c      CALL SKIP(1)
c      READ(1,*) ISONDE
      CALL SKIP(1)
      READ(1,*) NLYR
      CALL SKIP(4)

      DO 10 LC = 1, NLYR + 1
	 READ(1,*) ZKM(LC), PMB(LC), TK(LC)
10    CONTINUE
      CALL SKIP(4)

      DO 20 LC = 1, NLYR
	 READ(1,*) DUM, DUM, O3DU(LC), BEXMIE(LC), SSALBM(LC)
	 GH(LC) = GG
20    CONTINUE

   

c      IF(IDIFF.LT.1 .OR. IDIFF.GT.2) CALL NERRMSG(1,IDIFF)
c      IF(ISPHER.LT.1 .OR. ISPHER.GT.2) CALL NERRMSG(1,ISPHER)
c      IF(ALBEDO.LT.0.0 .OR. ALBEDO .GT.1.0 ) CALL NERRMSG(1,ALBEDO)
c      IF(MISCAT.LT.1 .OR. MISCAT.GT.2 ) CALL NERRMSG(1,MISCAT)
c      IF(IPHAS.LT.1 .OR. IPHAS.GT.2) CALL NERRMSG(1,IPHAS)
c      IF(IDELM.LT.1 .OR. IDELM.GT.2) CALL NERRMSG(1,IDELM)
c      IF(ISONDE.LT.1 .OR. ISONDE.GT.2) CALL NERRMSG(1,ISONDE)


      CLOSE(1)


      RETURN
      END

C ********************* END OF READIN *********************************** 

C ********************* SUBROUTINE NERRMSG *******************************

c      SUBROUTINE NERRMSG(IFATAL,VARNAM)
      

c      CHARACTER*(*) VARNAM

c      IF(IFATAL.EQ.1) THEN
c         WRITE(6,100) VARNAM
c100      FORMAT(1X,'INPUT ERROR :     ', A )
c         STOP
c      END IF

c      RETURN
c      END

C ******************** END OF NERRMSG ************************************

C ******************* SUBROUTINE SKIP ***********************************

      SUBROUTINE SKIP(N)

      DO 10 I = 1, N
	READ(1,*)
10    CONTINUE

      RETURN
      END

C ******************** END OF SKIP **************************************

